#include <stdio.h>
#include <descrip.h>

/* External references */
extern unsigned long merge_image(struct dsc$descriptor_s *image_name_p,
				 unsigned long (*entry_point)());

globalref CTL$AG_CLITABLE;

/* Macro definitions */
#define OK(s)	     ((s&1)==1)
#define WARNING(s)   ((s&7)==0)
#define ERROR(s)     ((s&7)==2)
#define SEVERE(s)    ((s&7)==4)

/* Data */
static unsigned long (*entry_point)();

/* Code */
static void usage()
{
    fprintf(stderr, "usage: do_command <command> ...\n");
    fprintf(stderr, " where <command> is some form of the directory command\n");
    exit(0);
}

main(int argc, char *argv[])
{
    $DESCRIPTOR(image_name, "SYS$SYSTEM:DIRECTORY.EXE");
    $DESCRIPTOR(command_line, "");
    struct dsc$descriptor_s *image_name_p;
    struct dsc$descriptor_s *command_line_p;
    unsigned long status;
    int i;

    if (argc < 2) {
	usage();
    }
    image_name_p = &image_name;
    status = merge_image(image_name_p, &entry_point);
    fprintf(stderr, "merge_image status is %X\n", status);
    if (!OK(status)) return(status);

    for (i=1; i < argc; i++) {
	command_line.dsc$a_pointer = argv[i];
	command_line.dsc$w_length = strlen(argv[i]);
	command_line_p = &command_line;
	/* Parse command line, using process command tables */
	status = CLI$DCL_PARSE(command_line_p, CTL$AG_CLITABLE);
	fprintf(stderr, "Parse status is %X\n", status);
	if (!OK(status)) {
	    break;
	}
	/* Call the image as a subroutine! */
	status = (*entry_point)();
	fprintf(stderr, "Image status is %X\n", status);
	if (WARNING(status)) {
	    status = 1;
	} else if (!OK(status)) {
	    break;
	}
    }
    return(status);
}
